package edu.cmu.cs.distributed.intro.ex05;

import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

public class ExecutorStuff {
	public static void main(String[] args) {
		ExecutorService executor = Executors.newCachedThreadPool();
		Future<?> future = executor.submit(new Runnable() {
			@Override
			public void run() {
				System.out.println("Running!");
			}
		});

		try {
			future.get();
		} catch (InterruptedException e) {
			// This won't happen in this case.
		} catch (ExecutionException e) {
			// An exception happened in the run() method above!
			e.getCause().printStackTrace();
		}

		ScheduledExecutorService schExec = Executors.newScheduledThreadPool(8);
		ScheduledFuture<?> schFuture = schExec.scheduleAtFixedRate(new Runnable() {
			@Override
			public void run() {
				System.out.println("ping");
			}
		}, 0, 1, TimeUnit.SECONDS);
	}
}
