package edu.cmu.cs.distributed.intro.ex03;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class Student {
	private final String firstName;
	private final int age;
	private final List<String> teachers;
	private final Map<String, Double> grades;
	
	public Student(String firstName, int age) {
		this.firstName = firstName;
		this.age = age;
		this.teachers = new ArrayList<String>();
		this.grades = new HashMap<String, Double>();
	}
	
	public String getFirstName() {
		return firstName;
	}

	public int getAge() {
		return age;
	}

	public List<String> getTeachers() {
		return teachers;
	}

	public Map<String, Double> getGrades() {
		return grades;
	}
	
	public void addTeacher(String teacher) {
		teachers.add(teacher);
	}
	
	public void addGrade(String course, double grade) {
		grades.put(course, grade);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + age;
		result = prime * result
				+ ((firstName == null) ? 0 : firstName.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Student other = (Student) obj;
		if (age != other.age)
			return false;
		if (firstName == null) {
			if (other.firstName != null)
				return false;
		} else if (!firstName.equals(other.firstName))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Student [firstName=" + firstName + ", age=" + age
				+ ", teachers=" + teachers + ", grades=" + grades + "]";
	}

	public static void main(String[] args) {
		Set<Student> students = new HashSet<Student>();
		Student me = new Student("Steven", 22);
		me.addGrade("15-440", 4.0);
		me.addTeacher("gkesden");
		students.add(me);
		
		for (Student student : students) {
			System.out.println(student);
		}
	}
}