
import java.io.*;

public class io {

	public static void main(String[] args) throws IOException {
		
		/* java.io.File represents a file or directory */
		File tmp = new File("/tmp");
		System.out.println("/tmp is file? " + tmp.isFile());
		System.out.println("/tmp is directory? " + tmp.isDirectory());
		System.out.println("/tmp is writable? " + tmp.canWrite());

		/* Random access files: provide random access to file contents. */
		File f = File.createTempFile("mytmp", "dat");
		System.out.println("Created tmp file at " + f);

		RandomAccessFile raf = new RandomAccessFile(f, "rw");
		
		raf.writeBytes("These are the contents of my file!");

		raf.seek(0);
		System.out.println("contents: ``" + readBytes(raf, raf.length()) + "''");

		raf.seek(0);
		System.out.println("First 5 characters are: " + readBytes(raf, 5)
						   + "; our pos: " + raf.getFilePointer());

		raf.seek(2);
		raf.writeBytes("o");

		raf.seek(0);
		System.out.println("contents: ``" + readBytes(raf, raf.length()) + "''");


		f.delete();
	}

	private static String readBytes(RandomAccessFile r, long len) throws IOException {
		long pos = r.getFilePointer();
		StringBuilder s = new StringBuilder((int)len);
		for (long i=0; i<len; i++) {
			s.append((char)r.readByte());
		}
		r.seek(pos); // let's avoid side effects
		return s.toString();
	}

}