
import java.io.*;
import java.util.*;

/*
  Key for serialization: implement java.io.Serializable
 */

// note: I'm playing fast and loose with exceptions: I wouldn't advise it
public class serialization {
	public static void main(String[] args) throws IOException, ClassNotFoundException {

		// Let's serialize some dates
		ObjectOutput s = new ObjectOutputStream(new FileOutputStream("dumbserialize.dat"));
		s.writeObject("Today");
		s.writeObject(new Date());
		s.flush();

		/*
		  $ cat dumbserialize.dat
		  ��tTodaysrjava.util.Datehj�KYtxp<fTb�x
		  $ date
		  Wed Jan 23 18:30:00 EST 2013
		*/

		// Now let's read it back
		ObjectInputStream in = new ObjectInputStream(new FileInputStream("dumbserialize.dat"));
		String today = (String)in.readObject();
		Date date = (Date)in.readObject();
		
		System.out.println("We read back: {str = " + today + "; date = " + date + "}");

		//////////////////////////////////////////////////////////////////////////////

		Flower f = new Flower();
		f.numPetals = 5;
		f.isUltraviolet = false;

		s = new ObjectOutputStream(new FileOutputStream("flowerserialize.dat"));
		s.writeObject(f);
		s.flush();

		in = new ObjectInputStream(new FileInputStream("flowerserialize.dat"));
		Flower maybeF = (Flower)in.readObject();
		System.out.println("Our flower had " + maybeF.numPetals + " petals");
	}
}

/* Default serialization works for non-transient, non-static fields */
class Flower implements Serializable {

	private static final long serialVersionUID = 42L;

	public int numPetals;
	public boolean isUltraviolet;
}

class ProblemPetal { // notice we don't implement Serializable
	public int prettyAmount;

	public ProblemPetal(int prettyAmount) {
		super();
		this.prettyAmount = prettyAmount;
	}	
}