/* Process vs Threads: self-contained execution environment vs running
 * parts of a thread. Important difference: communication between
 * processes is done with IPC; between threads with memory (or
 * higher-level constructs) */

/* Say we want a thread: we either create it ourselves or abstract it
 * to an executor (for later) */

/* Important classes: java.lang.Runnable, java.lang.Thread */

public class threads {

	public static void main(String[] args) {
		
		// spawn thread
		(new Thread(new Runnable(){
				public void run() {
					System.out.println("child running!");
				}
			})).start();
		
		new Thread(new child()).start();
		Thread t = new sleeper();
		t.start();

		new bored(t).start();

		try {
			t.join();
		} catch (Exception e) {}
		System.out.println("Our starter thread is done!");
	}
}


class child implements Runnable {
	public void run() {
		System.out.println("our own child is running!");
	}
}


// class sleeper implements Runnable {
    // public void run() {
		// ???
	// }
// }

class sleeper extends Thread {
	public void run() {
		System.out.println("sleeper started");
		try {
			sleep(100000000); // milliseconds
		} catch (InterruptedException e) {
			// Oh no -- an interrupt!
			System.out.println("sleeper just got interrupted :(");
		}
		System.out.println("done sleeping!");
	}
}

class bored extends Thread {

	private Thread toKill;

	public bored(Thread toKill) {
		super();
		this.toKill = toKill;
	}

	public void run() {
		System.out.println("bored started");
		try {
			sleep(2000); // = 2secs // sleep in milliseconds
		} catch (InterruptedException e) {}
		toKill.interrupt();
		System.out.println("bored successfully interrupted");
	}
}